C***********************************
C***********************************
C***********************************
C       Make sure you set process_replay.inc to have the correct file format
C       monitor file you are looking at, the file format has changed over
C       the years.
C       If you are on a newer version of FORTRAN but using an old record
C       format then you MUST!!!! add in /ALIGNMENT=RECORD=PACKED or the
C       prgram will crash when run or will show 17-NOV-1858 as the start
C       date in the header.
C
C       FORTRAN /ALIGNMENT=(COMMONS=(PACKED),RECORDS=PACKED)/WARN=NOALIGN/LIST PROCESS_REPLAY
C
C***********************************
C***********************************
C***********************************
C***********************************

C*
	PROGRAM  PROCESS_REPLAY
C*
C*	This program will read through a MONITOR/RECORD file and display
C*	information on an individual process (ie: almost the same as
C*	doing a MONITOR PROCESS/INPUT=xxx/DISPLAY=yyy then searching
C*	the display file for the process ID).
C*
C******************************************************************************
C*	The format for calling this program is
C*	REPLAY input_file_name process_id
C*		/OUTPUT=output_file_name 		(/OUTPUT=SYS$OUTPUT)
C*		/[NO]LEF				(/NOLEF)
C*		/[NO]STATUS				(/NOSTATUS)
C*****************************************************************************

	INCLUDE '($STSDEF)'
	INCLUDE	'PROCESS_REPLAY.INC'

	CHARACTER*16384	RECORD_STRING  ! The Process record can be over 8500

	CHARACTER*80	FILE_NAME,
	1		OUTNAME,
	2		DATE_OUT
	CHARACTER*25	RECORD_TEXT
	CHARACTER*8	PROCESS_ID_STRING
	CHARACTER*5	COMPUTE_COUNT

	INTEGER*4	DATE_LEN
	INTEGER*2	LENGTH,
	1		OUTNAME_SIZE
	LOGICAL		THERE

	INTEGER		CLI$PRESENT,
	1		CLI$GET_VALUE
	EXTERNAL	CLI$_PRESENT,
	1		CLI$_DEFAULTED
C*
C*            Get the input file
C*
	ISTATUS = CLI$GET_VALUE ('INFILE',FILE_NAME)
	IF (.NOT. ISTATUS) CALL LIB$STOP (%VAL(ISTATUS))

C*
C*            Get the process ID that the user wants to replay
C*
	ISTATUS = CLI$GET_VALUE ('PROCESS_ID',PROCESS_ID_STRING,LENGTH)
	IF (.NOT. ISTATUS) CALL LIB$STOP (%VAL(ISTATUS))
	DECODE (LENGTH,500,PROCESS_ID_STRING(1:LENGTH)) PROCESS_ID
500	FORMAT(Z<LENGTH>)

C*
C*		Check to see of the file is there.
C*
	INQUIRE(FILE=FILE_NAME,EXIST=THERE)
	IF (.NOT.THERE) THEN
		TYPE 100, FILE_NAME
		GOTO 9999
	ENDIF
100	FORMAT('0NO SUCH FILE: ',A)

C*
C*	Check to see if the user wants to see all of the LEF records
C*
	IF ((CLI$PRESENT ('LEF') .EQ. %LOC(CLI$_PRESENT)) .OR.
	1	(CLI$PRESENT ('LEF') .EQ. %LOC(CLI$_DEFAULTED))) THEN
			LEF = .TRUE.
        	ELSE
			LEF = .FALSE.
	ENDIF

C*
C*	Check to see if the user wants to see all of the text description
C*	of the STS field
C*
	IF ((CLI$PRESENT ('STATUS') .EQ. %LOC(CLI$_PRESENT)) .OR.
	1	(CLI$PRESENT ('STATUS') .EQ. %LOC(CLI$_DEFAULTED))) THEN
			STS_STATUS = .TRUE.
        	ELSE
			STS_STATUS = .FALSE.
	ENDIF

C*
C*	Find out where the output is going to
C*
	IF ((CLI$PRESENT ('OUTPUT') .EQ. %LOC(CLI$_PRESENT)) .OR.
	1	(CLI$PRESENT ('OUTPUT') .EQ. %LOC(CLI$_DEFAULTED))) THEN

		ISTATUS = CLI$GET_VALUE('OUTPUT',OUTNAME,OUTNAME_SIZE)
		IF (.NOT. ISTATUS) CALL LIB$STOP(%VAL(ISTATUS))
	ENDIF

C*
C*	Open the output file
C*
	OPEN(UNIT=20,
	1	FILE=OUTNAME(1:OUTNAME_SIZE),
	2	STATUS='NEW',
	3	FORM='FORMATTED')

C*
C*	Set the Line Counter so we will force a page break and zero other
C*	"LAST" information.
C*
	LINE_COUNT = 99
	COMPUTABLE = 0
	HAVE_PROCESS = .FALSE.
	LAST_CPU = 0
	LAST_TIME(1) = 0
	LAST_TIME(2) = 0

C*
C*	Open the Monitor File, use SHARED just in case you are reading an
C*	active recording file.
C*
	OPEN (UNIT=10, FILE=FILE_NAME,STATUS='OLD',READONLY,SHARED)

10	READ (10,110,END=1000) LENGTH, RECORD_STRING
110	FORMAT (Q,A)
D	type * , 'length of record =', length

C*
C*	Extract the Record Type Field.
C*
	CALL COPY_STRING_TO_RECORD(RECORD_STRING,CLASS_HEADER_REC.OVERLAY
	1		,0,len(CLASS_HEADER_REC.overlay))

C*
C*	Check to see if we have a Process Record
C*
	IF (CLASS_HEADER_REC.MNR_CLS$B_TYPE .EQ. MNR_PRO$_TYPE)
	1	CALL PROCESS_RECORD (CLASS_HEADER_REC,RECORD_STRING)

	GOTO 10

C*
C*	Check to see if we did not create any output
C*
1000	IF (LINE_COUNT .EQ. 99) WRITE (20,200)

200	FORMAT('1','There were no records found to match the criteria.')

	CLOSE (UNIT=10)
	CLOSE (UNIT=20)
9999	END



C******************************************************************************
C*
C*	This subroutine simply copies one string to another. It is used
C*	to copy parts of the string we read in to the proper record format
C*
	SUBROUTINE COPY_STRING_TO_RECORD
	1	(INSTRING,OUTSTRING,START_POS,NUM_CHARS)

	CHARACTER*(*)	INSTRING
	CHARACTER*(*)	OUTSTRING
	INTEGER		START_POS,
	1		NUM_CHARS

	DO I = 1, NUM_CHARS
		OUTSTRING(I:I) = INSTRING(START_POS+I:START_POS+I)
	END DO

	RETURN
	END

C******************************************************************************
C*
C*	This subroutine performs the processing that we want when we hit
C*	a PROCESS RECORD.
C*
	SUBROUTINE PROCESS_RECORD (CLASS_HEADER_REC,RECORD_STRING)

	INCLUDE '($LIBDTDEF)'
	INCLUDE	'PROCESS_REPLAY.INC'

	CHARACTER*(*)	RECORD_STRING
	CHARACTER*80	DATE_OUT
	CHARACTER*40	TEXT_STRING
	CHARACTER*16	CPUTIME_STRING
	CHARACTER*3	CPU_PERCENT
	REAL*4		CPUTIME_F
	INTEGER*4	DATE_LEN,
	1		COMPUTABLE,
	2		CPUTIME_WORK(2)
	INTEGER*2	CPUTIME_LEN,
	1		CPU_PERCENT_LEN
	BYTE		CURRENT_PRIORITY

	CALL COPY_STRING_TO_RECORD(RECORD_STRING,
	1		CLASS_PREFIX_REC.OVERLAY,
	2		len(CLASS_HEADER_REC.overlay),
	3		len(CLASS_PREFIX_REC.overlay))

C*
C*	Loop through each of the processes held in this record.
C*
	DO I = 1, CLASS_PREFIX_REC.MNR_CMP$L_ELTCT
		CALL COPY_STRING_TO_RECORD(RECORD_STRING,
	1		PROCESS_REC.OVERLAY,
	2		len(CLASS_PREFIX_REC.overlay)+
	3		len(class_header_rec.overlay)+((I-1)*
	4		len(process_rec.overlay)),
	5		len(process_rec.overlay))
                                                               
		IF ((PROCESS_REC.MNR_PRO$W_STATE .EQ. SCH$C_COM) .OR.
	1	(PROCESS_REC.MNR_PRO$W_STATE .EQ. SCH$C_COMO))
	2		COMPUTABLE = COMPUTABLE + 1

C*
C*	If we hit the process id we want then save the record for later use.
C*
		IF (PROCESS_ID .EQ. PROCESS_REC.MNR_PRO$L_EPID) THEN
			SAVE_PROCESS.OVERLAY = PROCESS_REC.OVERLAY
			HAVE_PROCESS = .TRUE.
		ENDIF

	END DO

C*
C*	Check to see if the process is in an LEF state and if the user
C*	does not want to look at LEF states, then turn off the HAVE_PROCESS
C*	indicator.
C*
	IF ((SAVE_PROCESS.MNR_PRO$W_STATE .EQ. SCH$C_LEF) .AND.
	1	(.NOT. LEF)) HAVE_PROCESS = .FALSE.

C*
C*	Report if found the process we want (unless we still have more records
C*	to read in for this snap-shot).
C*
	IF (.NOT. (CLASS_HEADER_REC.MNR_CLS$B_FLAGS .AND. 1)) THEN

		IF (HAVE_PROCESS) THEN
C*
C*	Get the date/time that the record was created
C*
			CALL LIB$FORMAT_DATE_TIME(DATE_OUT,
	1			CLASS_HEADER_REC.MNR_CLS$Q_STAMP,,TIME_LEN,
	2			LIB$M_TIME_FIELDS)

C*
C*	Convert the State into a String.
C*
			CALL GET_STATE (SAVE_PROCESS.MNR_PRO$W_STATE,
	1		SAVE_PROCESS.MNR_PRO$L_EFWM,
	2		TEXT_STRING)

C*
C*	Convert the Integer containing the CPU time in 10 ms ticks into
C*	a F value containing seconds with 2 decimal points
C*
			CPUTIME_F = SAVE_PROCESS.MNR_PRO$L_CPUTIM
			CPUTIME_F = CPUTIME_F / 100

C*
C*	Convert the Decimal Seconds into a VMS time
C*
			CALL LIB$CVTF_TO_INTERNAL_TIME(
	1			LIB$K_DELTA_SECONDS_F,
	2			CPUTIME_F,
	3			CPUTIME_WORK)

C*
C*	Convert the VMS Time into a text string.
C*
			ISTATUS = SYS$ASCTIM(CPUTIME_LEN,
	1			CPUTIME_STRING,CPUTIME_WORK)

C*
C*	Calculate the Percentage of CPU used by this process
C*
			CALL CALC_CPU_PERCENT(SAVE_PROCESS.MNR_PRO$L_CPUTIM,
	1		CLASS_HEADER_REC.MNR_CLS$Q_STAMP,
	1		CPU_PERCENT,CPU_PERCENT_LEN)

C*
C*	Check to see if we need to put a heading out
C*
			IF (LINE_COUNT .GT. 55) CALL PRINT_HEADINGS
			LINE_COUNT = LINE_COUNT + 1

C*
C*	If the process name changes then we put out another heading,
C*	since LAST_LNAME is set in the PRINT_HEADINGS, we won't repeat a
C*	page break if we have just done one.
C*
			IF (SAVE_PROCESS.MNR_PRO$T_LNAME .NE. LAST_LNAME)
	1				CALL PRINT_HEADINGS

C*
C*	For some reason we have to subtract the priority from 31 to get
C*	the actual current priority.
C*
			CURRENT_PRIORITY = 31 - SAVE_PROCESS.MNR_PRO$B_PRI
C*
C*	Write out our information
C*
			WRITE (20,300) DATE_OUT,
	1		TEXT_STRING,
	2		CURRENT_PRIORITY,
	3		SAVE_PROCESS.MNR_PRO$L_GPGCNT,
	4		SAVE_PROCESS.MNR_PRO$L_PPGCNT,
	5		SAVE_PROCESS.MNR_PRO$L_PAGEFLTS,
	6		SAVE_PROCESS.MNR_PRO$L_DIOCNT,
	7		SAVE_PROCESS.MNR_PRO$L_BIOCNT,
	8 		SAVE_PROCESS.MNR_PRO$L_STS,
	9		CPUTIME_STRING(1:CPUTIME_LEN),
	1		CPU_PERCENT(1:CPU_PERCENT_LEN),
	2 		COMPUTABLE


300	FORMAT (1X,A<TIME_LEN>,X,A30,X,I2,X,I8,X,I8,X,I8,X,I8,
	1		X,I8,X,Z8,X,A16,X,A3,X,I3)

C*
C*	If the user wants to see the status descriptions then show them
C*
	IF (STS_STATUS) CALL PRINT_STATUS (SAVE_PROCESS.MNR_PRO$L_STS)

		ENDIF
C*
C*	Reset for the next record.
C*
		COMPUTABLE = 0
		HAVE_PROCESS = .FALSE.

	ENDIF

	RETURN
	END

C******************************************************************************
C*
C*	This subroutine checks to see if the process is in a state
C*	that we want to look at.
C*
	SUBROUTINE GET_STATE (PROCESS_STATE,EVENT_FLAG,TEXT_STRING)

	INCLUDE	'PROCESS_REPLAY.INC'

	CHARACTER*(*)	TEXT_STRING

	INTEGER*4	EVENT_FLAG

	INTEGER*2	PROCESS_STATE

	TEXT_STRING = ' '

C*
C*	Set TEXT_STRING based on the process state
C*
	IF (PROCESS_STATE .EQ. SCH$C_COLPG) TEXT_STRING = SCH$T_COLPG
	IF (PROCESS_STATE .EQ. SCH$C_CEF) TEXT_STRING = SCH$T_CEF
	IF (PROCESS_STATE .EQ. SCH$C_PFW) TEXT_STRING = SCH$T_PFW
	IF (PROCESS_STATE .EQ. SCH$C_LEF) TEXT_STRING = SCH$T_LEF
	IF (PROCESS_STATE .EQ. SCH$C_LEFO) TEXT_STRING = SCH$T_LEFO
	IF (PROCESS_STATE .EQ. SCH$C_HIB) TEXT_STRING = SCH$T_HIB
	IF (PROCESS_STATE .EQ. SCH$C_HIBO) TEXT_STRING = SCH$T_HIBO
	IF (PROCESS_STATE .EQ. SCH$C_SUSP) TEXT_STRING = SCH$T_SUSP
	IF (PROCESS_STATE .EQ. SCH$C_SUSPO) TEXT_STRING = SCH$T_SUSPO
	IF (PROCESS_STATE .EQ. SCH$C_FPG) TEXT_STRING = SCH$T_FPG
	IF (PROCESS_STATE .EQ. SCH$C_COM) TEXT_STRING = SCH$T_COM
	IF (PROCESS_STATE .EQ. SCH$C_COMO) TEXT_STRING = SCH$T_COMO
	IF (PROCESS_STATE .EQ. SCH$C_CUR) TEXT_STRING = SCH$T_CUR

C*	If the process is in a MWAIT then find out which one.
C*
	IF (PROCESS_STATE .EQ. SCH$C_MWAIT)
	1		CALL CONVERT_MWAIT_TEXT (EVENT_FLAG,TEXT_STRING)

	RETURN
	END


C******************************************************************************
C*
C*	This subroutine converts the Integer value of the Event Flag
C*	into the text description of the MWAIT.
C*
	SUBROUTINE CONVERT_MWAIT_TEXT (EVENT_FLAG,MWAIT_TEXT)

	INCLUDE	'PROCESS_REPLAY.INC'

	CHARACTER*(*)	MWAIT_TEXT
	INTEGER*4	EVENT_FLAG

	MWAIT_TEXT = 'MUTEX - Mutual Exclusive Semaphore'

	IF (EVENT_FLAG .EQ. RSN$_ASTWAIT) MWAIT_TEXT = RSN$T_ASTWAIT
	IF (EVENT_FLAG .EQ. RSN$_MAILBOX) MWAIT_TEXT = RSN$T_MAILBOX
	IF (EVENT_FLAG .EQ. RSN$_NPDYNMEM) MWAIT_TEXT = RSN$T_NPDYNMEM
	IF (EVENT_FLAG .EQ. RSN$_PGFILE) MWAIT_TEXT = RSN$T_PGFILE
	IF (EVENT_FLAG .EQ. RSN$_PGDYNMEM) MWAIT_TEXT = RSN$T_PGDYNMEM
	IF (EVENT_FLAG .EQ. RSN$_BRKTHRU) MWAIT_TEXT = RSN$T_BRKTHRU
	IF (EVENT_FLAG .EQ. RSN$_IACLOCK) MWAIT_TEXT = RSN$T_IACLOCK
	IF (EVENT_FLAG .EQ. RSN$_JQUOTA) MWAIT_TEXT = RSN$T_JQUOTA
	IF (EVENT_FLAG .EQ. RSN$_LOCKID) MWAIT_TEXT = RSN$T_LOCKID
	IF (EVENT_FLAG .EQ. RSN$_SWPFILE) MWAIT_TEXT = RSN$T_SWPFILE
	IF (EVENT_FLAG .EQ. RSN$_MPLEMPTY) MWAIT_TEXT = RSN$T_MPLEMPTY
	IF (EVENT_FLAG .EQ. RSN$_MPWBUSY) MWAIT_TEXT = RSN$T_MPWBUSY
	IF (EVENT_FLAG .EQ. RSN$_SCS) MWAIT_TEXT = RSN$T_SCS
	IF (EVENT_FLAG .EQ. RSN$_CLUSTRAN) MWAIT_TEXT = RSN$T_CLUSTRAN
	IF (EVENT_FLAG .EQ. RSN$_CPUCAP) MWAIT_TEXT = RSN$T_CPUCAP
	IF (EVENT_FLAG .EQ. RSN$_CLUSRV) MWAIT_TEXT = RSN$T_CLUSRV


	RETURN
	END

C******************************************************************************
C*
C*	This subroutine calculates the percentage of CPU time that this
C*	process has used since the last record we printed.
C*
	SUBROUTINE CALC_CPU_PERCENT (CPUTIM,RECORD_TIME,CPU_PERCENT,LEN)

	INCLUDE '($LIBDTDEF)'
	INCLUDE	'PROCESS_REPLAY.INC'

	CHARACTER*(*)	CPU_PERCENT

	REAL*4		DIFF_SECONDS_F

	INTEGER*4	CPUTIM,
	1		RECORD_TIME(2),
	2		CPU_INT,
	3		DIFF_CPU,
	4		DIFF_TIME(2),
	5		DIFF_SECONDS

	INTEGER*2	LEN

C*
C*	If the LAST_TIME (date/time that the last record we processed was
C*	created) is 0 then print out some stars.
C*
	IF ((LAST_TIME(1) .EQ. 0) .AND. (LAST_TIME(2) .EQ. 0)) THEN
		CPU_PERCENT = '***'
		LEN = 3
	ELSE
C*
C*	Find out the difference in time between the last record we
C*	processed and this record.
C*
		CALL LIB$SUB_TIMES (RECORD_TIME,LAST_TIME,DIFF_TIME)

C*
C*	Convert this from the internal date/time format into a number of
C*	seconds (using an F type field so we keep the decimal points).
C*
		CALL LIB$CVTF_FROM_INTERNAL_TIME(LIB$K_DELTA_SECONDS_F,
	1			DIFF_SECONDS_F,
	2			DIFF_TIME)

C*
C*	Make sure that we are not going to divide by zero.
C*
		IF (DIFF_SECONDS_F .EQ. 0.0) THEN
			CPU_PERCENT = '  0'
		    ELSE
C*
C*	Convert our difference into the same format as the CPU Time
C*	field that Monitor stores.
C*
			DIFF_SECONDS_F = DIFF_SECONDS_F * 100

C*
C*	Since Monitor stores the CPU time as an integer value of
C*	10 ms ticks, we can simply subtract the current value from the
C*	last to get the difference
*
			DIFF_CPU = CPUTIM - LAST_CPU
C*
C*	Calculate the actual percentage, multipling by 1000 then adding 50
C*	and dividing by 10 gives us the value rounded to the nearest
C*	percentage point.
C*
			CPU_INT = (((DIFF_CPU * 1000) / DIFF_SECONDS_F)
	1				 + 5) / 10

C*
C*	Fingure out how many characters will be in the final string
C*	(used for the ENCODE and to right justify the number when it
C*	is printed)
C*
			LEN = 1
			IF (CPU_INT .GE. 10) LEN = 2
			IF (CPU_INT .GE. 100) LEN = 3
C*
C*	If we don't set the string to '   ' before the encode then the
C*	encode overlays the value on the stars. (ie. instead of getting
C*	'58 ' we get '58*'.)
C*
			CPU_PERCENT = '   '
			ENCODE (3,500,CPU_PERCENT) CPU_INT
		   ENDIF
	ENDIF

500	FORMAT(I<LEN>)

C*
C*	Reset for the next call to the routine.
C*
	LAST_TIME(1) = RECORD_TIME(1)
	LAST_TIME(2) = RECORD_TIME(2)
	LAST_CPU = CPUTIM

	RETURN
	END

C******************************************************************************
C*
C*	This subroutine finds out the text descriptions of the STS (Status)
C*	field and calls a rountine to print the description.
C*
	SUBROUTINE PRINT_STATUS (STATUS_FIELD)

	INCLUDE	'PROCESS_REPLAY.INC'

	INTEGER*4	STATUS_FIELD

	IF ((STATUS_FIELD .AND. PCB$M_RES) .EQ. (PCB$M_RES))
	1			CALL PRINT_LINE (PCB$T_RES)
	IF ((STATUS_FIELD .AND. PCB$M_DELPEN) .EQ. (PCB$M_DELPEN))
	1			CALL PRINT_LINE (PCB$T_DELPEN)
	IF ((STATUS_FIELD .AND. PCB$M_FORCPEN) .EQ. (PCB$M_FORCPEN))
	1			CALL PRINT_LINE (PCB$T_FORCPEN)
	IF ((STATUS_FIELD .AND. PCB$M_INQUAN) .EQ. (PCB$M_INQUAN))
	1			CALL PRINT_LINE (PCB$T_INQUAN)
	IF ((STATUS_FIELD .AND. PCB$M_PSWAPM) .EQ. (PCB$M_PSWAPM))
	1			CALL PRINT_LINE (PCB$T_PSWAPM)
	IF ((STATUS_FIELD .AND. PCB$M_RESPEN) .EQ. (PCB$M_RESPEN))
	1			CALL PRINT_LINE (PCB$T_RESPEN)
	IF ((STATUS_FIELD .AND. PCB$M_SSFEXC) .EQ. (PCB$M_SSFEXC))
	1			CALL PRINT_LINE (PCB$T_SSFEXC)
	IF ((STATUS_FIELD .AND. PCB$M_SSFEXCE) .EQ. (PCB$M_SSFEXCE))
	1			CALL PRINT_LINE (PCB$T_SSFEXCE)
	IF ((STATUS_FIELD .AND. PCB$M_SSFEXCS) .EQ. (PCB$M_SSFEXCS))
	1			CALL PRINT_LINE (PCB$T_SSFEXCS)
	IF ((STATUS_FIELD .AND. PCB$M_SSFEXCU) .EQ. (PCB$M_SSFEXCU))
	1			CALL PRINT_LINE (PCB$T_SSFEXCU)
	IF ((STATUS_FIELD .AND. PCB$M_SSRWAIT) .EQ. (PCB$M_SSRWAIT))
	1			CALL PRINT_LINE (PCB$T_SSRWAIT)
	IF ((STATUS_FIELD .AND. PCB$M_SUSPEN) .EQ. (PCB$M_SUSPEN))
	1			CALL PRINT_LINE (PCB$T_SUSPEN)
	IF ((STATUS_FIELD .AND. PCB$M_WAKEPEN) .EQ. (PCB$M_WAKEPEN))
	1			CALL PRINT_LINE (PCB$T_WAKEPEN)
	IF ((STATUS_FIELD .AND. PCB$M_WALL) .EQ. (PCB$M_WALL))
	1			CALL PRINT_LINE (PCB$T_WALL)
	IF ((STATUS_FIELD .AND. PCB$M_BATCH) .EQ. (PCB$M_BATCH))
	1			CALL PRINT_LINE (PCB$T_BATCH)
	IF ((STATUS_FIELD .AND. PCB$M_NOACNT) .EQ. (PCB$M_NOACNT))
	1			CALL PRINT_LINE (PCB$T_NOACNT)
	IF ((STATUS_FIELD .AND. PCB$M_NOSUSPEND) .EQ. (PCB$M_NOSUSPEND))
	1			CALL PRINT_LINE (PCB$T_NOSUSPEND)
	IF ((STATUS_FIELD .AND. PCB$M_ASTPEN) .EQ. (PCB$M_ASTPEN))
	1			CALL PRINT_LINE (PCB$T_ASTPEN)
	IF ((STATUS_FIELD .AND. PCB$M_PHDRES) .EQ. (PCB$M_PHDRES))
	1			CALL PRINT_LINE (PCB$T_PHDRES)
	IF ((STATUS_FIELD .AND. PCB$M_HIBER) .EQ. (PCB$M_HIBER))
	1			CALL PRINT_LINE (PCB$T_HIBER)
	IF ((STATUS_FIELD .AND. PCB$M_LOGIN) .EQ. (PCB$M_LOGIN))
	1			CALL PRINT_LINE (PCB$T_LOGIN)
	IF ((STATUS_FIELD .AND. PCB$M_NETWRK) .EQ. (PCB$M_NETWRK))
	1			CALL PRINT_LINE (PCB$T_NETWRK)
	IF ((STATUS_FIELD .AND. PCB$M_PWRAST) .EQ. (PCB$M_PWRAST))
	1			CALL PRINT_LINE (PCB$T_PWRAST)
	IF ((STATUS_FIELD .AND. PCB$M_NODELET) .EQ. (PCB$M_NODELET))
	1			CALL PRINT_LINE (PCB$T_NODELET)
	IF ((STATUS_FIELD .AND. PCB$M_DISAWS) .EQ. (PCB$M_DISAWS))
	1			CALL PRINT_LINE (PCB$T_DISAWS)
	IF ((STATUS_FIELD .AND. PCB$M_INTER) .EQ. (PCB$M_INTER))
	1			CALL PRINT_LINE (PCB$T_INTER)
	IF ((STATUS_FIELD .AND. PCB$M_RECOVER) .EQ. (PCB$M_RECOVER))
	1			CALL PRINT_LINE (PCB$T_RECOVER)
	IF ((STATUS_FIELD .AND. PCB$M_SECAUDIT) .EQ. (PCB$M_SECAUDIT))
	1			CALL PRINT_LINE (PCB$T_SECAUDIT)
	IF ((STATUS_FIELD .AND. PCB$M_HARDAFF) .EQ. (PCB$M_HARDAFF))
	1			CALL PRINT_LINE (PCB$T_HARDAFF)
	IF ((STATUS_FIELD .AND. PCB$M_ERDACT) .EQ. (PCB$M_ERDACT))
	1			CALL PRINT_LINE (PCB$T_ERDACT)
	IF ((STATUS_FIELD .AND. PCB$M_SOFTSUSP) .EQ. (PCB$M_SOFTSUSP))
	1			CALL PRINT_LINE (PCB$T_SOFTSUSP)
	IF ((STATUS_FIELD .AND. PCB$M_PREEMPTED) .EQ. (PCB$M_PREEMPTED))
	1			CALL PRINT_LINE (PCB$T_PREEMPTED)

	RETURN
	END

C******************************************************************************
C*
C*	This subroutine prints out the text descriptions of the STS (STATUS)
C*	field.
C*
	SUBROUTINE PRINT_LINE (TEXT_STRING)

	INCLUDE	'PROCESS_REPLAY.INC'

	CHARACTER*(*)	TEXT_STRING

	IF (LINE_COUNT .GT. 55) CALL PRINT_HEADINGS
	LINE_COUNT = LINE_COUNT + 1

	WRITE (20,100) TEXT_STRING

100	FORMAT (20X,'******',X,A)

	RETURN
	END

C******************************************************************************
C*
C*	This subroutine prints out the headings at the top of the page
C*
	SUBROUTINE PRINT_HEADINGS

	INCLUDE	'PROCESS_REPLAY.INC'

	CHARACTER*80	DATE_OUT
	INTEGER*4	DATE_LEN
	INTEGER		LNAME_LEN


C*
C*	Save the process name so we know to put out a new page heading when
C*	the process name changes.
C*
	LAST_LNAME = SAVE_PROCESS.MNR_PRO$T_LNAME

C*
C*	Find out how long the process name is
C*
	LNAME_LEN = ICHAR(SAVE_PROCESS.MNR_PRO$T_LNAME(1:1))
C*
C*	Get the current date/time
C*
	CALL LIB$FORMAT_DATE_TIME(DATE_OUT,,,DATE_LEN)
C*
C*	Write out our Heading
C*
	WRITE (20,100) PROCESS_ID
	WRITE (20,110) SAVE_PROCESS.MNR_PRO$T_LNAME(2:LNAME_LEN+1),
	1		SAVE_PROCESS.MNR_PRO$W_UIC_GRP,
	2		SAVE_PROCESS.MNR_PRO$W_UIC_MEM
	WRITE (20,130)
	WRITE (20,140)

	LINE_COUNT = 4

100	FORMAT('1',50X,'Process Replay for:',X,Z8.8)
110	FORMAT(X,'Process Name:',X,A<LNAME_LEN>,X,'UIC: [',
	1		O4.4,',',O4.4,']')
130	FORMAT (1X)
140	FORMAT (1X,'Time',<TIME_LEN-5>X,2X,'State',26X,'PRI',2X,
	1	'GPGCNT',3X,'PPGCNT',X,'PAGEFLTS',3X,'DIOCNT',
	2	2X,'BIOCNTS',2X,'Status',4X,'CPU Time',6X,
	3	'%CPU',X,'COM')

	RETURN
	END

